﻿using System;
using System.Text;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;
using Newtonsoft.Json.Linq;
using System.Diagnostics;
using System.Threading;
using System.Net;

namespace esl
{
    class FastTrackREST
    {
        public static void main()
        {
            HttpClient httpClient = new HttpClient();
            httpClient.DefaultRequestHeaders.Add("Authorization", "Basic " + Properties.Settings.Default.key);
            httpClient.DefaultRequestHeaders.Add("Accept", "application/json; esl-api-version=11.0");

            //Create template
            string json = "{\"autocomplete\":true,\"description\":\"This is a package created using the eSignLive SDK\",\"documents\":[{\"approvals\":[{\"fields\":[{\"extract\":false,\"height\":50,\"left\":100,\"page\":0,\"subtype\":\"FULLNAME\",\"top\":100,\"type\":\"SIGNATURE\",\"width\":200}],\"role\":\"signer1\"},{\"fields\":[{\"extract\":false,\"height\":50,\"left\":400,\"page\":0,\"subtype\":\"FULLNAME\",\"top\":100,\"type\":\"SIGNATURE\",\"width\":200}],\"role\":\"PlaceholderId1\"}],\"extract\":false,\"fields\":[],\"id\":\"doc1\",\"index\":0,\"name\":\"First Document\",\"pages\":[]}],\"emailMessage\":\"This message should be delivered to all signers\",\"messages\":[],\"name\":\"StartFastTrackExample Template: 11/3/2016 9:52:21 AM\",\"roles\":[{\"attachmentRequirements\":[],\"id\":\"signer1\",\"index\":0,\"locked\":false,\"name\":\"signer1\",\"reassign\":false,\"signers\":[{\"auth\":{\"challenges\":[],\"scheme\":\"NONE\"},\"email\":\"mail33@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"professionalIdentityFields\":[],\"specialTypes\":[],\"userCustomFields\":[]}],\"specialTypes\":[]},{\"attachmentRequirements\":[],\"id\":\"PlaceholderId1\",\"index\":0,\"locked\":false,\"name\":\"PlaceholderId1\",\"reassign\":false,\"signers\":[],\"specialTypes\":[]}],\"trashed\":false,\"type\":\"TEMPLATE\",\"visibility\":\"ACCOUNT\"}";
            StringContent jsonContent = new StringContent(json, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes(@"C:/Users/hhaidary/Desktop/PDFs/doc1.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"doc1.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"doc1.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            var templateResponse = httpClient.PostAsync(new Uri("https://sandbox.esignlive.com/api/packages"), form).Result;
            JObject templateObject = JObject.Parse(templateResponse.Content.ReadAsStringAsync().Result);

            //Debug.WriteLine(templateObject["id"]);

            Thread.Sleep(10000);

            //Start fast track
            var fastTrackResponse = httpClient.GetAsync(new Uri("https://sandbox.esignlive.com/api/fastTrack/" + templateObject["id"] + "/url?signing=True")).Result;
            JObject urlObject = JObject.Parse(fastTrackResponse.Content.ReadAsStringAsync().Result);

            //Debug.WriteLine(urlObject);

            string url = urlObject["url"].ToString();
            string uriString = string.Empty;

            HttpWebRequest request = (HttpWebRequest)(WebRequest.Create(url));

            using (HttpWebResponse response = (HttpWebResponse)request.GetResponse())

            {
                uriString = response.ResponseUri.AbsoluteUri;
                
            }

            string jsonString = "[{\"id\":\"PlaceholderId1\",\"name\":\"PlaceholderId1\",\"signers\":[{\"id\":\"PlaceholderId1\",\"email\":\"mail43@mailinator.com\",\"firstName\":\"Patty\",\"lastName\":\"Galant\"}]}]";
            StringContent cont = new StringContent(jsonString, Encoding.UTF8, "application/json");

            string token = uriString.Replace("https://sandbox.esignlive.com/ft?token=", "");

            var httpResponse = httpClient.PostAsync(new Uri("https://sandbox.esignlive.com/api/fastTrack?token=" + token), cont).Result;
            JObject jsonResponse = JObject.Parse(httpResponse.Content.ReadAsStringAsync().Result);

            string fastUrl = jsonResponse["url"].ToString();
            Debug.WriteLine(fastUrl);

        }
    }
}
